# Agile Core

**Collection of PHP Traits for designing object-oriented frameworks.**

[![Build Status](https://travis-ci.org/atk4/core.png?branch=develop)](https://travis-ci.org/atk4/core)
[![Code Climate](https://codeclimate.com/github/atk4/core/badges/gpa.svg)](https://codeclimate.com/github/atk4/core)
[![StyleCI](https://styleci.io/repos/57242416/shield)](https://styleci.io/repos/57242416)
[![codecov](https://codecov.io/gh/atk4/core/branch/develop/graph/badge.svg)](https://codecov.io/gh/atk4/core)
[![Issue Count](https://codeclimate.com/github/atk4/core/badges/issue_count.svg)](https://codeclimate.com/github/atk4/core)

[![License](https://poser.pugx.org/atk4/core/license)](https://packagist.org/packages/atk4/core)
[![GitHub release](https://img.shields.io/github/release/atk4/core.svg?maxAge=2592000)](https://packagist.org/packages/atk4/core)



Agile Core was created for [Agile Data](https://github.com/atk4/data) and [Agile UI](https://github.com/atk4/ui), but can be used in any other framework too. You will mostly find PHP Traits here, that add functionality into your objects such as:

- Containers: Implements Parent/Child relations between your objects
- Hooks: Create hooks and register callbacks with priorities and arguments
- Initializers: Automatically execute init() method of your object
- Dynamic Methods: Add methods dynamically into existing objects
- Factory: Specify class name as a string
- App Scope: Inject global "app" object and pass it to new objects

Additionally you a much better 'Exception' class for general-purpose exceptions.

## [Documentation](http://agile-core.readthedocs.io/en/develop/)

http://agile-core.readthedocs.io/

## Community and Support

[![Gitter](https://img.shields.io/gitter/room/atk4/data.svg?maxAge=2592000)](https://gitter.im/atk4/dataset?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![Stack Overlfow Community](https://img.shields.io/stackexchange/stackoverflow/t/atk4.svg?maxAge=2592000)](http://stackoverflow.com/questions/ask?tags=atk4)
[![Discord User forum](https://img.shields.io/badge/discord-User_Forum-green.svg)](https://forum.agiletoolkit.org/c/44)

##  Install from Composer

```
composer require atk4/core
```

## Agile Toolkit

Agile Core is part of [Agile Toolkit - PHP UI Framework](http://agiletoolkit.org). If you like this project, you should also look into:

- [DSQL](https://github.com/atk4/dsql) - [![GitHub release](https://img.shields.io/github/release/atk4/dsql.svg?label=DSQL)]()
- [Agile Data](https://github.com/atk4/data) - [![GitHub release](https://img.shields.io/github/release/atk4/data.svg?label=Agile+Data)]()
- [Agile UI](https://github.com/atk4/ui) - [![GitHub release](https://img.shields.io/github/release/atk4/ui.svg?label=Agile+UI)]()

